/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Author:  .......
 *
 * File Description:
 *   .......
 *
 * Remark:
 *   This code was originally generated by application DATATOOL
 *   using specifications from the data definition file
 *   'omssa.asn'.
 */

// standard includes

// generated includes
#include <ncbi_pch.hpp>
#include "Mod.hpp"
#include <objects/omssa/MSModSpecSet.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


CMSMod::CMSMod(const CMSSearchSettings::TVariable &Mods, CRef<CMSModSpecSet> Modset)
{
    Init(Mods, Modset);
}

bool CMSMod::Init(const CMSSearchSettings::TVariable &Mods,
                  CRef<CMSModSpecSet> Modset)
{
    bool retval(false);

    CMSSearchSettings::TVariable::const_iterator iMods;
    if (!Modset || !Modset->IsArrayed()) {
        ERR_POST(Error << "CMSMod::Init: not able to use modification arrays");
        return false;
    }
    for(iMods = Mods.begin(); iMods != Mods.end(); iMods++) {
        // if methionine cleavage, skip
        if(*iMods == eMSMod_ntermmcleave) {
            retval = true;
            continue;
        }
	    ModLists[Modset->GetModType(*iMods)].push_back(*iMods);
    }
    return retval;
}

END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

/* Original file checksum: lines: 59, chars: 1831, CRC32: 7e7a0ad6 */
