"<!DOCTYPE HTML><html>\n"
"   <header>\n"
"      <title>PubSeq Gateway - Help Page</title>\n"
"      <style>\n"
"					table, th, td {\n"
"						border: 1px solid;\n"
"						padding: 10px;\n"
"						}\n"
"					table {\n"
"						border-collapse: collapse;\n"
"						}\n"
"					th {\n"
"						background-color: #D8D8D8;\n"
"						font-size: larger;\n"
"						font-weight: bold;\n"
"					}\n"
"					table.first-column > tbody > tr > td:nth-of-type(1) {\n"
"						font-size: larger;\n"
"						font-weight: bold;\n"
"						background-color: #F5F5F5;\n"
"					}\n"
"					table.nested td {\n"
"						border-color: silver;\n"
"					}\n"
"\n"
"				</style>\n"
"   </header>\n"
"   <body>\n"
"      <h1>PubSeq Gateway</h1>\n"
"      <p>Accession resolution and retrieval of bio-sequences. Retrieval of named annotations.</p>\n"
"      <table>\n"
"         <tr>\n"
"            <td>version</td>\n"
"            <td>0.0.0</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>build-date</td>\n"
"            <td>Apr 25 2023 15:45:29</td>\n"
"         </tr>\n"
"      </table><br><hr><br><br><h2>Commands</h2>\n"
"      <ul>\n"
"         <li><a href=\"#ID_getblob\">ID/getblob</a></li>\n"
"         <li><a href=\"#ID_get\">ID/get</a></li>\n"
"         <li><a href=\"#ID_get_tse_chunk\">ID/get_tse_chunk</a></li>\n"
"         <li><a href=\"#ID_resolve\">ID/resolve</a></li>\n"
"         <li><a href=\"#ID_get_na\">ID/get_na</a></li>\n"
"         <li><a href=\"#ID_get_acc_ver_history\">ID/get_acc_ver_history</a></li>\n"
"         <li><a href=\"#IPG_resolve\">IPG/resolve</a></li>\n"
"         <li><a href=\"#ADMIN_config\">ADMIN/config</a></li>\n"
"         <li><a href=\"#ADMIN_info\">ADMIN/info</a></li>\n"
"         <li><a href=\"#ADMIN_status\">ADMIN/status</a></li>\n"
"         <li><a href=\"#ADMIN_shutdown\">ADMIN/shutdown</a></li>\n"
"         <li><a href=\"#ADMIN_get_alerts\">ADMIN/get_alerts</a></li>\n"
"         <li><a href=\"#ADMIN_ack_alerts\">ADMIN/ack_alerts</a></li>\n"
"         <li><a href=\"#ADMIN_statistics\">ADMIN/statistics</a></li>\n"
"         <li><a href=\"#TEST_io\">TEST/io</a></li>\n"
"         <li><a href=\"#favicon.ico\">favicon.ico</a></li>\n"
"         <li><a href=\"#unknown\">unknown</a></li>\n"
"      </ul><a id=\"ID_getblob\"></a><h2>ID/getblob</h2>\n"
"      <p>Retrieves blob chunks basing on the blob identifier</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>blob_id</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">&lt;sat&gt;.&lt;sat_key&gt;. The blob sat and sat key. Both must be positive integers.</td>\n"
"            <td>Non empty string. The interpretation of the blob id depends on a processor. Cassandra\n"
"               processor expects the following format: &lt;sat&gt;.&lt;sat key&gt; where boath are integers</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>tse</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">TSE option controls what blob is provided:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>Value</td>\n"
"                     <td>ID2 split available</td>\n"
"                     <td>ID2 split not available</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>none</td>\n"
"                     <td>Nothing</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>whole</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>orig</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>smart</td>\n"
"                     <td>All split blobs</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>slim</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>none, whole, orig, smart and slim</td>\n"
"            <td>orig</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>last_modified</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">The blob last modification. If provided then the exact match will be requested with\n"
"               the Cassandra storage corresponding field value.</td>\n"
"            <td>Positive integer. Not provided means that the most recent match will be selected.</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>client_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The client identifier. If provided then the exclude blob feature takes place.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>send_blob_if_small</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\"></td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>0</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The PSG protocol is used in the HTTP body. The blob properties and chunks are provided.</p>\n"
"      <hr><br><br><a id=\"ID_get\"></a><h2>ID/get</h2>\n"
"      <p>Retrieves blob chunks basing on the seq_id and seq_id_type</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Sequence identifier</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_type</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Sequence identifier type</td>\n"
"            <td>Integer type greater than 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>tse</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">TSE option controls what blob is provided:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>Value</td>\n"
"                     <td>ID2 split available</td>\n"
"                     <td>ID2 split not available</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>none</td>\n"
"                     <td>Nothing</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>whole</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>orig</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>smart</td>\n"
"                     <td>All split blobs</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>slim</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>none, whole, orig, smart and slim</td>\n"
"            <td>orig</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>exclude_blobs</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A comma separated list of blob identifiers which client already has. If provided then\n"
"               if the resolution of sequence identifier/sequence identifier type matches one of the\n"
"               blob identifiers in the list then the blob will not be sent. The format of the blob\n"
"               identifier depends on a processor. For example, a Cassandra processor expects the\n"
"               format as &lt;sat&gt;.&lt;sat key&gt; where both of them are integers. Note: it works in conjunction\n"
"               with the client_id parameter.</td>\n"
"            <td>A list of blob indentifiers</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>client_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The client identifier. If provided then the exclude blob feature takes place.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>acc_substitution</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls how the bioseq info accession substitution is done. If the substitution\n"
"               is needed then the seq_ids list is analyzed. If there is one with Gi then it is taken\n"
"               for substitution. Otherwise an arbitrary one is picked. The supported policy values\n"
"               are:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>default</td>\n"
"                     <td>substitute if version value (version &lt;= 0) or seq_id_type is Gi(12)</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>limited</td>\n"
"                     <td>substitute only if the resolved record's seq_id_type is GI(12)</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>never</td>\n"
"                     <td>the accession substitution is never done</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>limited, never or default</td>\n"
"            <td>default</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>send_blob_if_small</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\"></td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>0</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>resend_timeout</td>\n"
"            <td>optional</td>\n"
"            <td>Float</td>\n"
"            <td class=\"description\">If the blob has already been sent to the client more than this time ago then the blob\n"
"               will be sent anyway. If less then the 'already sent' reply will have an additional\n"
"               field 'sent_seconds_ago' with the corresponding value. The special value 0 means that\n"
"               the blob will be sent regardless when it was already sent.</td>\n"
"            <td>Floating point value greater or equal 0.0</td>\n"
"            <td>Taken from [SERVER]/resend_timeout configuration setting</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_resolve</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">If yes then use the full resolution procedure using all provided sequence identifiers.\n"
"               Otherwise use only bioseq info table and GI sequence identifiers.</td>\n"
"            <td>yes and no</td>\n"
"            <td>yes</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The PSG protocol is used in the HTTP body. The bioseq info, blob properties and chunks\n"
"         are provided.</p>\n"
"      <hr><br><br><a id=\"ID_get_tse_chunk\"></a><h2>ID/get_tse_chunk</h2>\n"
"      <p>Retrieves a TSE blob chunk</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>id2_chunk</td>\n"
"            <td>mandatory</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">The tse blob chunk number. The Cassandra processor recognizes a special value of 999999999\n"
"               for the parameter. In this case the effective chunk number will be taken from the\n"
"               id2_info parameter</td>\n"
"            <td>Integer greater or equal 0. Some processors may introduce more strict rules. For example,\n"
"               Cassandra processor requires the chunk number to be greater than 0.</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>id2_info</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The following formats are recognized:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>Cassandra processor, option 1</td>\n"
"                     <td>3 or 4 integers separated by '.': &lt;sat&gt;.&lt;info&gt;.&lt;chunks&gt;[.&lt;split version&gt;]</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>Cassandra processor, option 2</td>\n"
"                     <td>psg~~tse_id-&lt;sat&gt;.&lt;sat key&gt;[~~tse_last_modified-&lt;int&gt;[~~tse_split_version-&lt;int&gt;]</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>Other processors</td>\n"
"                     <td>id2~~tse_id-&lt;string&gt;~~tse_last_modified-&lt;int&gt;~~tse_split_version-&lt;int&gt;</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>A string in a format recognisable by one of the processors</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The PSG protocol is used in the HTTP body. The blob properties and chunks are provided.</p>\n"
"      <hr><br><br><a id=\"ID_resolve\"></a><h2>ID/resolve</h2>\n"
"      <p>Resolve seq_id and provide bioseq info</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Sequence identifier</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_type</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Sequence identifier type</td>\n"
"            <td>Integer type greater than 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>fmt</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The format of the data sent to the client. Available options:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>protobuf</td>\n"
"                     <td>bioseq info will be sent as a protobuf binary data</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>json</td>\n"
"                     <td>bioseq info will be sent as a serialized JSON dictionary</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>native</td>\n"
"                     <td>the server decides what format to use: protobuf or json</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>protobuf, json or native</td>\n"
"            <td>native</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>all_info</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>canon_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_ids</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>mol_type</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>length</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>state</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>blob_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>tax_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hash</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>date_changed</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>gi</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>name</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_state</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A flag to specify explicitly what values to include/exclude from the provided bioseq\n"
"               info</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>acc_substitution</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls how the bioseq info accession substitution is done. If the substitution\n"
"               is needed then the seq_ids list is analyzed. If there is one with Gi then it is taken\n"
"               for substitution. Otherwise an arbitrary one is picked. The supported policy values\n"
"               are:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>default</td>\n"
"                     <td>substitute if version value (version &lt;= 0) or seq_id_type is Gi(12)</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>limited</td>\n"
"                     <td>substitute only if the resolved record's seq_id_type is GI(12)</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>never</td>\n"
"                     <td>the accession substitution is never done</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>limited, never or default</td>\n"
"            <td>default</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_resolve</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">If yes then use the full resolution procedure using all provided sequence identifiers.\n"
"               Otherwise use only bioseq info table and GI sequence identifiers.</td>\n"
"            <td>yes and no</td>\n"
"            <td>yes</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The bioseq info is sent back in the HTTP body as binary protobuf or as PSG protocol\n"
"         chunks depending on the protocol choice</p>\n"
"      <hr><br><br><a id=\"ID_get_na\"></a><h2>ID/get_na</h2>\n"
"      <p>Retrieves named annotations</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Sequence identifier. This or seq_ids parameter value must be provided for the request.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_ids</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A space separated list of the sequence identifier synonims. This or seq_id parameter\n"
"               value must be provided for the request.</td>\n"
"            <td>A list of space separated string identifiers</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_type</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Sequence identifier type</td>\n"
"            <td>Integer type greater than 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>names</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A comma separated list of named annotations to be retrieved.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>fmt</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The format of the data sent to the client. Available options:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>protobuf</td>\n"
"                     <td>bioseq info will be sent as a protobuf binary data</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>json</td>\n"
"                     <td>bioseq info will be sent as a serialized JSON dictionary</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>native</td>\n"
"                     <td>the server decides what format to use: protobuf or json</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>protobuf, json or native</td>\n"
"            <td>native</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>tse</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">TSE option controls what blob is provided:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>Value</td>\n"
"                     <td>ID2 split available</td>\n"
"                     <td>ID2 split not available</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>none</td>\n"
"                     <td>Nothing</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>whole</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>Nothing</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>orig</td>\n"
"                     <td>Split INFO blob only</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>smart</td>\n"
"                     <td>All split blobs</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>slim</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                     <td>All Cassandra data chunks of the blob itself</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>none, whole, orig, smart and slim</td>\n"
"            <td>none</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>client_id</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The client identifier. If provided then the exclude blob feature takes place.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>send_blob_if_small</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\"></td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>0</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_resolve</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">If yes then use the full resolution procedure using all provided sequence identifiers.\n"
"               Otherwise use only bioseq info table and GI sequence identifiers.</td>\n"
"            <td>yes and no</td>\n"
"            <td>yes</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>resend_timeout</td>\n"
"            <td>optional</td>\n"
"            <td>Float</td>\n"
"            <td class=\"description\">If the blob has already been sent to the client more than this time ago then the blob\n"
"               will be sent anyway. If less then the 'already sent' reply will have an additional\n"
"               field 'sent_seconds_ago' with the corresponding value. The special value 0 means that\n"
"               the blob will be sent regardless when it was already sent.</td>\n"
"            <td>Floating point value greater or equal 0.0</td>\n"
"            <td>Taken from [SERVER]/resend_timeout configuration setting</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>snp_scale_limit</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">GenBank ID2 SNP reader parameter</td>\n"
"            <td>chromosome, contig, supercontig, unit and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The PSG protocol is used in the HTTP body. The bioseq info and named annotation chunks\n"
"         are provided.</p>\n"
"      <hr><br><br><a id=\"ID_get_acc_ver_history\"></a><h2>ID/get_acc_ver_history</h2>\n"
"      <p>Retrieves accession version history</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Sequence identifier</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>seq_id_type</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Sequence identifier type</td>\n"
"            <td>Integer type greater than 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>use_cache</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option controls if the Cassandra LMDB cache and/or database should be used. It\n"
"               affects the seq id resolution step and the blob properties lookup step. The following\n"
"               options are available:<br><br><table class=\"nested\">\n"
"                  <tr>\n"
"                     <td>no</td>\n"
"                     <td>do not use LMDB cache (tables SI2CSI, BIOSEQ_INFO and BLOB_PROP) at all; use only\n"
"                        Cassandra database for the lookups.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td>yes</td>\n"
"                     <td>do not use tables SI2CSI, BIOSEQ_INFO and BLOB_PROP in the Cassandra database; use\n"
"                        only the LMDB cache.</td>\n"
"                  </tr>\n"
"                  <tr>\n"
"                     <td></td>\n"
"                     <td>use the LMDB cache if at all possible; then, fallback to Cassandra storage.</td>\n"
"                  </tr>\n"
"               </table>\n"
"            </td>\n"
"            <td>yes, no and not provided</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>hops</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">A numbers of hops before the request reached the server</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The PSG protocol is used in the HTTP body. The bioseq info and accession version history\n"
"         chunks are provided.</p>\n"
"      <hr><br><br><a id=\"IPG_resolve\"></a><h2>IPG/resolve</h2>\n"
"      <p>Resolve nucleotide/protein/ipg and provide ipg info</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>protein</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The protein to be resolved. It may be ommitted if ipg is provided.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>nucleotide</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The nucleotide to be resolved.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>ipg</td>\n"
"            <td>mandatory</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">The ipg to be resolved. It may be ommitted if protein is provided.</td>\n"
"            <td>An integer greater than 0</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>trace</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The option to include trace messages to the server output</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>enable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is allowed to process a request. The parameter can be\n"
"               repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>disable_processor</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">A name of a processor which is disallowed to process a request. The parameter can\n"
"               be repeated as many times as needed.</td>\n"
"            <td>A string</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>processor_events</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Switch on/off additional reply chunks which tell about the processor</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The ipg record(s) is sent baback in the HTTP body as PSG protocol chunks</p>\n"
"      <hr><br><br><a id=\"ADMIN_config\"></a><h2>ADMIN/config</h2>\n"
"      <p>Provides the server configuration information</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a JSON dictionary with the configuration information.</p>\n"
"      <hr><br><br><a id=\"ADMIN_info\"></a><h2>ADMIN/info</h2>\n"
"      <p>Provides the server run-time information</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a JSON dictionary with the run-time information like resource consumption</p>\n"
"      <hr><br><br><a id=\"ADMIN_status\"></a><h2>ADMIN/status</h2>\n"
"      <p>Provides the server event counters</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a JSON dictionary with various event counters</p>\n"
"      <hr><br><br><a id=\"ADMIN_shutdown\"></a><h2>ADMIN/shutdown</h2>\n"
"      <p>Performs the server shutdown</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>username</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The user name who requested the shutdown</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>auth_token</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Authorization token. If the configuration [ADMIN]/auth_token value is configured then\n"
"               the request must have the token value matching the configured to be granted.</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>timeout</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">The timeout in seconds within which the shutdown must be performed. If 0 then it leads\n"
"               to an immediate shutdown. If 1 or more seconds then the server will reject all new\n"
"               requests and wait till the timeout is over or all the pending requests are completed\n"
"               and then do the shutdown.</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>10</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The standard HTTP protocol is used</p>\n"
"      <hr><br><br><a id=\"ADMIN_get_alerts\"></a><h2>ADMIN/get_alerts</h2>\n"
"      <p>Provides the server alerts</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a JSON dictionary with the current server alerts</p>\n"
"      <hr><br><br><a id=\"ADMIN_ack_alerts\"></a><h2>ADMIN/ack_alerts</h2>\n"
"      <p>Acknowledge an alert</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>alert</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The alert identifier to acknowledge</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>username</td>\n"
"            <td>mandatory</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">The user name who acknowledges the alert</td>\n"
"            <td>A string identifier</td>\n"
"            <td></td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The standard HTTP protocol is used</p>\n"
"      <hr><br><br><a id=\"ADMIN_statistics\"></a><h2>ADMIN/statistics</h2>\n"
"      <p>Provides the server collected statistics</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>reset</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">If provided then the collected statistics is rest. Otherwise the collected statistics\n"
"               is sent to the client.</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>most_recent_time</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Number of seconds in the past for the most recent time range limit</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>0</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>most_ancient_time</td>\n"
"            <td>optional</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Number of seconds in the past for the most ancient time range limit</td>\n"
"            <td>An integer greater or equal 0</td>\n"
"            <td>Effectively infinity, max integer</td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>histogram_names</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Comma separated list of the histogram names. If provided then the server returns all\n"
"               existing histograms (listed in histogram_names) which intersect with the specified\n"
"               time period.</td>\n"
"            <td>A comma separated list of string identifiers</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>time_series</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">Describes the aggregation of the per-minute data collected by the server. Format:\n"
"               &lt;int&gt;:&lt;int&gt;[ &lt;int:&lt;int&gt;]* &lt;int&gt;:\n"
"               There are pairs of integers divided by ':'. The pairs are divided by spaces. The first\n"
"               integer is how many minutes to be aggregated, the second integer is the last index\n"
"               of the data sequence to be aggregated. For each aggregation the server calculates\n"
"               the average number of requests per second. The last pair must not have the second\n"
"               integer - this is an item which describes the aggregation till the end of the available\n"
"               data. A special value is also supported: no. This value means that the server will\n"
"               not send time series data at all.</td>\n"
"            <td>no or aggregation description string</td>\n"
"            <td>1:59 5:1439 60:</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a JSON dictionary with the collected statistics information</p>\n"
"      <hr><br><br><a id=\"TEST_io\"></a><h2>TEST/io</h2>\n"
"      <p>Sends back random binary data to test the I/O performance. It works only if the server\n"
"         configuration file has the [DEBUG]/psg_allow_io_test value set to true</p>\n"
"      <table class=\"first-column\">\n"
"         <tr>\n"
"            <th>Parameter</th>\n"
"            <th>Optional</th>\n"
"            <th>Type</th>\n"
"            <th>Description</th>\n"
"            <th>Allowed Values</th>\n"
"            <th>Default</th>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>return_data_size</td>\n"
"            <td>mandatory</td>\n"
"            <td>Integer</td>\n"
"            <td class=\"description\">Size in bytes (positive integer up to 1000000000) which should be sent to the client.\n"
"               The data are random.</td>\n"
"            <td>An integer in the range 0 ... 1000000000</td>\n"
"            <td></td>\n"
"         </tr>\n"
"         <tr>\n"
"            <td>log</td>\n"
"            <td>optional</td>\n"
"            <td>String</td>\n"
"            <td class=\"description\">It tells if the logging of the request should be done or not</td>\n"
"            <td>yes and no</td>\n"
"            <td>no</td>\n"
"         </tr>\n"
"      </table>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body is a random data of the requested length</p>\n"
"      <hr><br><br><a id=\"favicon.ico\"></a><h2>favicon.ico</h2>\n"
"      <p>Always replies 'not found'</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The standard HTTP protocol is used</p>\n"
"      <hr><br><br><a id=\"unknown\"></a><h2>unknown</h2>\n"
"      <p>Always replies 'ok' in terms of http. The nested PSG protocol always tells 'bad request'</p>\n"
"      <h3>Reply</h3>\n"
"      <p>The HTTP body uses PSG protocol for a 'bad request' message</p>\n"
"      <hr><br><br><h2>References</h2>\n"
"      <ol>\n"
"         <li><a href=\"https://github.com/ncbi/cxx-toolkit/blob/gh-pages/misc/PSG%20Server.docx\">PubSeq Gateway Server Overview and the Protocol Specification</a></li>\n"
"      </ol>\n"
"   </body>\n"
"</html>\n"
